﻿using System;
using System.Reflection;

namespace ConsoleApp1
{
    class Program
    {
        static unsafe void Main(string[] args)
        {
            {
                MyStruct ms = new MyStruct();

                ulong m = 5;
                FieldInfo fi = typeof(MyStruct).GetField("dt", BindingFlags.Instance | BindingFlags.NonPublic);
                fi.SetValue(ms, m);

                Console.WriteLine(ms);
            }

            {
                MyStruct ms = new MyStruct();

                ulong m = 5;
                FieldInfo fi = typeof(MyStruct).GetField("dt", BindingFlags.Instance | BindingFlags.NonPublic);

                TypedReference tr = __makeref(ms);
                fi.SetValueDirect(tr, m);

                Console.WriteLine(ms);
            }

            {
                MyStruct ms = new MyStruct();

                ulong* p = (ulong *)&ms;
                {
                    *p = 5;
                }

                Console.WriteLine(ms);
            }
        }
    }

    public struct MyStruct
    {
        private ulong dt;

        public override string ToString()
        {
            return dt.ToString();
        }
    }
}
